<!-- Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.  This file is offered as-is,
without any warranty. -->

The Amalthea Library is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

---

## Amalthea

Amalthea is a small general Linux-specific library for D programming language.
It provides a few useful functions.

At present, while the library has not reached version 1.0, it is not recommended for use by all comers.
Current version 0.9.X is pre-release.

**Library documentation:** [https://vindexbit.gitlab.io/docs/amalthea.html](https://vindexbit.gitlab.io/docs/amalthea.html)

---

## Ready-made packages for ldc2

See [download page](https://gitlab.com/tech.vindex/amalthea/wikis/Download-page).

---

## Build from source

### Preparing

You must have at least one of these compilers:

* [Digital Mars D Compiler](https://dlang.org/download.html#dmd);

* [LLVM D Compiler](https://wiki.dlang.org/LDC).

Installing **ldc2** in Debian-based distributions:

`sudo apt install ldc`

Installing **dmd** in Debian-based distributions (only i386 and x86-64):

```

sudo wget http://master.dl.sourceforge.net/project/d-apt/files/d-apt.list -O /etc/apt/sources.list.d/d-apt.list

sudo apt update --allow-insecure-repositories

sudo apt -y --allow-unauthenticated install --reinstall d-apt-keyring

sudo apt install dmd-bin dmd-doc

```

Support for the **gdc** compiler has been suspended due to severe deprecation.


### Building

#### Simple building and installing

Creating of static and dynamic libraries for the **ldc2** compiler (by default):

`make`

Installation:

`sudo make install`

After that, the library for ldc2 is ready for use.

You can install the library in any other directory:

`make install DESTDIR=/home/$USER/sandbox`

Uninstalling:

`sudo make uninstall`

If you installed in an alternate directory:

`make uninstall DESTDIR=/home/$USER/sandbox`

#### Specific building

Choose other compiler (for example, dmd):

`make DC=dmd`

Installing:

`sudo make install DC=dmd`

Uninstalling:

`sudo make uninstall DC=dmd`

---


## Feedback

Questions, suggestions, comments, bugs:

**tech.vindex@gmail.com**

Also use the repository service tools.

---
